/**
 * Tests to verify the mock xhr service.
 *
 * @author Elliott Sprehn (esprehn@gmail.com)
 */
 
var MockXhrServiceTest = TestCase('MockXhrServiceTest');

MockXhrServiceTest.prototype.setUp = function() {
  this.xhr = new MockXhrService();
};

MockXhrServiceTest.prototype.testGetRequests = function() {
  this.xhr.expect('GET', '/products.json').respond([
    {id: 1, name: 'iPad'},
    {id: 2, name: 'Xoom'}
  ]);
  expectAsserts(1);
  this.xhr.get('/products.json', function(result) {
    assertEquals('iPad', result[0].name);
  });
  this.xhr.flush();
};

MockXhrServiceTest.prototype.testPostRequests = function() {
  this.xhr.expect('POST', '/products/1', {name: 'GalaxyTab'}).
    respond({success: true});
  expectAsserts(1);
  this.xhr.post('/products/1', {name: 'GalaxyTab'}, function(result) {
    assertTrue(result.success);
  });
  this.xhr.flush();
};

MockXhrServiceTest.prototype.testUnexpectedRequest = function() {
  var xhr = this.xhr;
  assertException(function() {
    xhr.get('/products/1', function() {});
  });
};

MockXhrServiceTest.prototype.testCalledWithSelf = function() {
  this.xhr.expect('GET', '/products/1').respond({});
  expectAsserts(1);
  this.xhr.get('/products/1', function() {
    assertEquals(11, this.value);
  }, {value: 11});
  this.xhr.flush();
};
